#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <linux/cdrom.h>

int main(int argc,char **argv)
{
	 int cdrom, ioctlres, exitcode=4;
	 
	 if (argc <= 1)
	 {
			printf("usage: %s [device]\nexit: 0 disk ready, 1 not ready, 2 tray open, 3 no disk, 4 anything else\n", argv[0]);
			exit(exitcode);
	 }
	 
	 if ((cdrom = open(argv[1],O_RDONLY | O_NONBLOCK)) < 0)
	 {
			perror("failed to open device");
			exit(exitcode);
	 }

	 if ((ioctlres = ioctl(cdrom,CDROM_DRIVE_STATUS)) < 0)
	 {
			perror("ioctl failed");
			exit(exitcode);
	 }
	 close(cdrom);

	 exitcode = (ioctlres == CDS_DISC_OK)? 0
			: (ioctlres == CDS_DRIVE_NOT_READY)? 1
			: (ioctlres == CDS_TRAY_OPEN)? 2
			: (ioctlres == CDS_NO_DISC)? 3
			: 4;
	 exit(exitcode);
}

